local jetfile = "client/CosmicMetal/JetColor.dat"
local flashfile = "client/CosmicMetal/FlashColor.dat"

COM_AddCommand("jetcolor", function(player, col)
	if player
		if col and R_GetColorByName(col)
			local f = io.openlocal(jetfile, "w+")
			f:write(col)
			f:close()
			rawset(_G, "jetcolor", R_GetColorByName(col))
			CONS_Printf(player, "Jet Color set to "..R_GetNameByColor(R_GetColorByName(col)))
		else
			CONS_Printf(player, "jetcolor <color> | Sets the color of Cosmetal's jets.")
		end
		S_StartSound(nil, sfx_addfil, player)
	end
end, COM_LOCAL)

COM_AddCommand("flashcolor", function(player, col)
	if player
		if col and R_GetColorByName(col)
			local f = io.openlocal(flashfile, "w+")
			f:write(col)
			f:close()
			rawset(_G, "flashcolor", R_GetColorByName(col))
			CONS_Printf(player, "Flash Color set to "..R_GetNameByColor(R_GetColorByName(col)))
		else
			CONS_Printf(player, "flashcolor <color> | Sets the color of Cosmetal's flashing.")
		end
		S_StartSound(nil, sfx_addfil, player)
	end
end, COM_LOCAL)

if not jetcolor
	local f = io.openlocal(jetfile, "r")
	if f
		rawset(_G, "jetcolor", R_GetColorByName(f:read("*a")))
		f:close()
	else
		rawset(_G, "jetcolor", SKINCOLOR_YELLOW)
	end
end

if not flashcolor
	local f = io.openlocal(flashfile, "r")
	if f
		rawset(_G, "flashcolor", R_GetColorByName(f:read("*a")))
		f:close()
	else
		rawset(_G, "flashcolor", SKINCOLOR_ORANGE)
	end
end

local tunefilename = "client/CosmicMetal/DJTunes.dat"
COM_AddCommand("metaltunes", function(player, name)
	if player
		if name
			local file = io.openlocal(tunefilename, "w+")
			if name == "default"
				rawset(_G, "metaltunes", "vsmetl")
				file:write("vsmetl")
				file:close()
			elseif name == "race"
				rawset(_G, "metaltunes", "bcz1")
				file:write("bcz1")
				file:close()
			end
			CONS_Printf(player, "Metal DJ Tunes set to "..name.."!")
		else
			CONS_Printf(player, "metaltunes <default/race> | Changes Cosmetal's DJ Music.")
		end
		S_StartSound(nil, sfx_addfil, player)
	end
end, COM_LOCAL)

if not metaltunes
	local f = io.openlocal(tunefilename, "r")
	if f
		rawset(_G, "metaltunes", f:read("*a"))
		f:close()
	else
		rawset(_G, "metaltunes", "vsmetl")
	end
end

local csfilename = "client/CosmicMetal/ColorScheme.dat"
COM_AddCommand("metalsupercolor", function(player, arg)
	if player
		if arg and (arg == "cobalt" or arg == "crimson" or arg == "green" or arg == "blackhole")
			local f = io.openlocal(csfilename, "w+")
			f:write(arg)
			f:close()
			rawset(_G, "metalsupercolor", arg)
			CONS_Printf(player, "Metal Super Color set to "..arg..".")
		else
			CONS_Printf(player, "Invalid argument! Usage: metalsupercolor <cobalt/crimson/green/blackhole> | Sets the super color of Cosmetal.")
		end
		S_StartSound(nil, sfx_addfil, player)
	end
end, COM_LOCAL)

if not metalsupercolor
	local f = io.openlocal(csfilename, "r")
	if f
		rawset(_G, "metalsupercolor", f:read("*a"))
		f:close()
	else
		rawset(_G, "metalsupercolor", "cobalt")
	end
end

--[[local stunefilename = "client/CosmicMetal/SuperTunes.dat"
COM_AddCommand("metalsupertunes", function(player, arg)
	if player
		if arg and (arg == "default" or arg == "fnaf")
			local f = io.openlocal(stunefilename, "w+")
			f:write(arg)
			f:close()
			rawset(_G, "metalsupertunes", arg)
			CONS_Printf(player, "Metal Super Tunes set to "..arg..".")
		else
			CONS_Printf(player, "Invalid argument! Usage: metalsupertunes <default/fnaf> | Sets the super tunes of Cosmetal.")
		end
		S_StartSound(nil, sfx_addfil, player)
	end
end, COM_LOCAL)

if not metalsupertunes
	local f = io.openlocal(stunefilename, "r")
	if f
		rawset(_G, "metalsupertunes", f:read("*a"))
		f:close()
	else
		rawset(_G, "metalsupertunes", "default")
	end
end
--]]