rawset(_G, "CMS", {})

//SkinCheck(mobj_t object, string skin)
function CMS.SkinCheck(mo, skin)
	if mo.skin == skin
		return true
	else
		return false
	end
end

function CMS.HoverThinker(player)
	if player.vboosting
		player.secondjump = 0
	end
	if player.secondjump
		player.mo.momz = max($*P_MobjFlip(player.mo), 0)
	end
end

//StartRocketBoost(player_t player, fixed_t speed, boolean ac, int sound, boolean setmomz)
function CMS.StartRocketBoost(player, speed, ac, sound, setmomz)
	player.start_speed = speed
	P_InstaThrust(player.mo, player.mo.angle, speed)
	player.dashmode = 108
	player.rboost_setmomz = setmomz
	player.mo.state = S_PLAY_DASH
	player.rboosting = true
	player.boost_timer = TICRATE/2
	if ac == true or ac == nil
		player.boost_cooldown = TICRATE*5
	end
	player.startangle = player.mo.angle
	if sound == nil then sound = sfx_kc40 end
	S_StartSound(player.mo, sound)
end

function CMS.MetalSuperAura(mo)
	if mo and mo.valid and mo.health
		if mo.target and mo.target.valid and mo.target.health
			if mo.target.skin == "cosmicmetal"
				A_CapeChase(mo, 0, 0)
				mo.scale = mo.target.scale+mo.target.scale/2
				mo.blendmode = AST_ADD
				mo.spriteyoffset = mo.target.spriteyoffset-mo.target.spriteyoffset/2
				mo.spritexoffset = mo.target.spritexoffset-mo.target.spritexoffset/2
				if not (mo.target.player.powers[pw_super])
					P_RemoveMobj(mo)
				end
			else
				P_RemoveMobj(mo)
			end
		else
			P_RemoveMobj(mo)
		end
	end
end

//MetalAura(mobj_t object, mobj_t target)
function CMS.MetalAura(mo,target)
	if not(target and target.valid and target.player and target.player.charging == true
	and target.player.charge_type == "blast"
		and target.player.playerstate == PST_LIVE)
		P_RemoveMobj(mo)
	return end
	mo.scale = target.scale
	if P_MobjFlip(target) == 1
		mo.eflags = $&~MFE_VERTICALFLIP
		P_TeleportMove(mo,target.x,target.y,target.z+target.height/4)
	else
		mo.eflags = $|MFE_VERTICALFLIP
		P_TeleportMove(mo,target.x,target.y,target.z+target.height*3/4)
	end
end

//EnergyGather(mobj_t object, mobj_t target, fixed_t xyangle, fixed_t zangle)
function CMS.EnergyGather(mo,target,xyangle,zangle)
	if not(target and target.valid and target.player and target.player.charging == true) then
		P_RemoveMobj(mo)
	return end
	local dist = mo.scale*4*16*mo.fuse
	local xydist = P_ReturnThrustX(nil,zangle,dist)
	local zdist = P_ReturnThrustY(nil,zangle,dist)
	local x = target.x+P_ReturnThrustX(nil,xyangle,xydist)
	local y = target.y+P_ReturnThrustY(nil,xyangle,xydist)
	local z = target.z+zdist+target.height/2
	P_TeleportMove(mo,x,y,z)
end

//StartCharge(player_t player, boolean effect)
function CMS.StartCharge(player, effect)
	if effect != "armageddon"
		S_StartSound(player.mo, sfx_bechrg)
	else
		S_StartSound(player.mo, sfx_s3k53)
	end
	if player.powers[pw_super] or effect == "blast"
		player.a = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_ENERGYAURA)
		if player.a and player.a.valid then 
			player.a.target = player.mo
			player.a.scale = player.mo.scale
			player.a.spriteyoffset = -16*FRACUNIT
		end
	end
	local effects = {"blast","boost","armageddon"}
	if effect == nil or not effects[effect]
		player.charge_type = "boost"
	else
		player.charge_type = effect
	end
	player.charging = true
	if effect == "boost" or effect == "armageddon"
		player.dashmode = 108
	end
	player.charge_speed = player.store_speed
	player.charge_timer = 0
end

//SetMomZ(mobj_t object, fixed_t momz)
function CMS.SetMomZ(mo, momz) 
	P_SetObjectMomZ(mo, momz, false)
end

//SpawnMetalImage(player_t player)
function CMS.SpawnMetalImage(player)
	local metalimage = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_METALIMAGE)
	metalimage.skin = player.mo.skin
	metalimage.state = player.mo.state
	metalimage.angle = player.drawangle
	metalimage.spriteyoffset = player.mo.spriteyoffset
	metalimage.fuse = 3
	metalimage.frame = player.mo.frame|FF_TRANS60
	metalimage.colorized = true
	metalimage.tics = -1
	metalimage.scale = player.mo.scale
	metalimage.destscale = 0
	metalimage.scalespeed = player.mo.scale/10
	return metalimage
end

function CMS.ShieldToColor(player) //This function is for when I can make sprites and I decide to make the super aura exist
	if not player.powers[pw_shield]
		return SKINCOLOR_NEON
	else
		if player.powers[pw_shield] == SH_ARMAGEDDON
			return SKINCOLOR_KETCHUP
		elseif player.powers[pw_shield] == SH_WHIRLWIND
			return SKINCOLOR_CLOUDY
		elseif player.powers[pw_shield] == SH_ELEMENTAL
			return SKINCOLOR_SALMON
		elseif (player.powers[pw_shield]&SH_FORCE)
			return SKINCOLOR_PURPLE
		elseif player.powers[pw_shield] == SH_ATTRACT
			return SKINCOLOR_YELLOW
		elseif player.powers[pw_shield] == SH_FLAMEAURA
			return SKINCOLOR_RED
		elseif player.powers[pw_shield] == SH_BUBBLEWRAP
			return SKINCOLOR_COBALT
		elseif player.powers[pw_shield] == SH_THUNDERCOIN
			return SKINCOLOR_WHITE
		elseif player.powers[pw_shield] == SH_PITY
			return SKINCOLOR_APPLE
		end
	end
end

function CMS.SpawnMissile(mo, missile_type)
	local m = P_SPMAngle(mo,missile_type,mo.angle,0)
	return m
end