freeslot("S_PLAY_METALAIM",
"MT_METALIMAGE",
"S_PLAY_METALDJ",
"SPR2_MDJ_",
"SPR2_OOF_",
"SPR2_FKIK",
"sfx_pity")

states[S_PLAY_METALAIM] = {
	sprite = SPR_PLAY,
	frame = SPR2_LAND|A,
	tics = 1,
	nextstate = S_PLAY_METALAIM
}

states[S_PLAY_METALDJ] = {
	sprite = SPR_PLAY,
	frame = SPR2_MDJ_|FF_ANIMATE|A,
	tics = -1,
	var1 = 1,
	var2 = 4,
	nextstate = S_PLAY_METALDJ
}

mobjinfo[MT_METALIMAGE] = {
	doomednum = -1,
	spawnstate = S_NULL,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP,
	radius = 5*FRACUNIT,
	height = 30*FRACUNIT,
	deathsound = sfx_ncspec
}

addHook("ShouldJingleContinue", function(player, musname)
	if player and player.mo and player.mo.skin == "cosmicmetal" and player.metaldj
		return true
	else
		return false
	end
end)

addHook("MobjMoveBlocked", function(mo, thing, line)
	--Rocket Boost Bonk
	if not (mo.player and mo.skin == "cosmicmetal") return end
	local player = mo.player
	if player.rboosting and (line and line.valid) and not thing
		if (line.frontsector)
			if (line.frontsector.ceilingheight == line.frontsector.floorheight) and (mo.z > line.frontsector.ceilingheight)
				return
			end
		end
		if (line.backsector)
			if (line.backsector.ceilingheight == line.backsector.floorheight) and (mo.z > line.backsector.ceilingheight)
				return
			end
		end
		player.rboosting = false
		player.boost_timer = 0
		player.secondjump = 0
		if player.powers[pw_shield] == SH_ARMAGEDDON
			P_BlackOw(player)
			P_RemoveShield(player)
		end
		local shake = FRACUNIT*32
		if not(player.powers[pw_shield]&SH_FORCEHP 
		and player.powers[pw_shield]&SH_FORCE)
			P_StartQuake(shake, TICRATE/3)
			S_StartSound(mo, sfx_pstop)
			P_SetObjectMomZ(mo, 8*FRACUNIT)
			P_InstaThrust(mo, player.drawangle-ANGLE_180, 14*FRACUNIT)
		else
			P_SetObjectMomZ(mo, 16*FRACUNIT)
			P_InstaThrust(mo, player.drawangle-ANGLE_180, 24*FRACUNIT)
		end
		player.pflags = $ & ~PF_JUMPED
		if player.powers[pw_shield]&SH_FORCEHP 
		and player.powers[pw_shield]&SH_FORCE
			S_StartSound(mo, sfx_ngskid)
			player.pflags = $|PF_SHIELDABILITY
			mo.state = S_PLAY_JUMP
			player.pflags = $|PF_JUMPED
			player.boost_cooldown = 0
		else
			player.boost_canceled = true
			player.powers[pw_nocontrol] = 1
			player.dashmode = 0
			mo.state = S_PLAY_PAIN
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo.skin != "cosmicmetal" then return end
	if not (player.mo and player.mo.valid) then return end
	
	if player.metalshield != (player.powers[pw_shield] & SH_NOSTACK)
	and not G_IsSpecialStage()
		player.metalshield = (player.powers[pw_shield] & SH_NOSTACK)
	end
	
	if supermusic or player.isxmomentum then
		player.hassupermusic = true
	end
	
	if player.mo.state == S_PLAY_DEAD
		player.mo.rollangle = $+ANGLE_22h
	end
	
	if player.powers[pw_super] 
		if player.mo.state == S_PLAY_SUPER_TRANS1
		and not player.musicplaying
			P_PlayJingleMusic(player, "bcz1", nil, true, JT_SUPER)
			player.musicplaying = true
		end
		if metalsupercolor == "crimson"
			player.mo.color = (SKINCOLOR_SUPERCRIMSON1 + abs( ( (player.powers[pw_super] >> 1) % 9) - 4))
		elseif metalsupercolor == "green"
			player.mo.color = (SKINCOLOR_SUPERGREEN1 + abs( ( (player.powers[pw_super] >> 1) % 9) - 4))
		elseif metalsupercolor == "blackhole"
			player.mo.color = (SKINCOLOR_SUPERBLACKHOLE1 + abs( ( (player.powers[pw_super] >> 1) % 9) - 4))
		end
--[[		
		if metalsupertunes == "fnaf"
			P_SetupLevelSky(9999)
			for s in sectors.iterate do
				if not lightlevelstore
					rawset(_G, "lightlevelstore", {})
					table.insert(lightlevelstore, s.lightlevel)
				end
				s.lightlevel = 0
			end
			S_StopSound(player.mo)
		end
		--]]
	end
	
	if player.waitTimer == nil or player.mo.state != S_PLAY_WAIT
		player.waitTimer = 0
	end
	
	if player.mo.state == S_PLAY_WAIT
		player.waitTimer = $+1
	end
	
	if player.powers[pw_super] 
		if(player.panim == PA_WALK or player.panim == PA_RUN or player.panim == PA_DASH)
			if P_IsObjectOnGround(player.mo)
				player.mo.spriteyoffset = FRACUNIT*8 + (3 * cos(ANG10*leveltime))
			end
		elseif player.mo.state == S_PLAY_WAIT
			player.mo.spriteyoffset = min((FRACUNIT*(player.waitTimer)), FRACUNIT*30 + (6 * cos(ANG10*player.waitTimer)))
			SpriteLib.HWave(player.mo, 6, 1, player.waitTimer)
		else
			player.mo.spriteyoffset = 0
			player.mo.spritexoffset = 0
		end
	else
		player.mo.spriteyoffset = 0
		player.mo.spritexoffset = 0
		player.musicplaying = false
	end
	
	if player.metaldj == nil
		player.metaldj = false
	end
	
	if player.cmd.buttons&BT_TOSSFLAG 
		if P_IsObjectOnGround(player.mo)
			if not player.dancetapped
				player.metaldj = not $
				if player.metaldj == true
					P_PlayJingleMusic(player, metaltunes, nil, true, JT_OTHER)
					player.pflags = $|PF_FULLSTASIS
				else
					if player.mo.state == S_PLAY_METALDJ
						player.mo.state = S_PLAY_STND
					end
					P_RestoreMusic(player)
					player.pflags = $ & ~PF_FULLSTASIS
				end
			end
			player.dancetapped = true
		end
	else
		player.dancetapped = false
	end
	
	if player.metaldj
		player.pflags = $|PF_FULLSTASIS
		if player.mo.state != S_PLAY_METALDJ
			player.mo.state = S_PLAY_METALDJ
		end
	end

	CMS.HoverThinker(player)
	
	if player.pflags&PF_SPINNING and not P_IsObjectOnGround(player.mo)
		player.pflags = $ & ~PF_SPINNING
		player.pflags = $|PF_JUMPED
	end
	
	if player.dashmode >= 3*TICRATE
		if not P_IsObjectOnGround(player.mo)
			player.dashmode = max(player.dashmode, 3*36)
		end
		player.normalspeed = skins[player.mo.skin].normalspeed*3/2
		player.fakenormalspeed = skins[player.mo.skin].normalspeed*3/2
		if not player.charging
		and not ((player.pflags&PF_STARTDASH) and player.mo.state == S_PLAY_METALAIM)
			local metalimage = CMS.SpawnMetalImage(player)
			if player.powers[pw_super]
				metalimage.color = SKINCOLOR_METALIMAGE_PURPLE
			else
				if gametyperules & GTR_TEAMS and player.mo.color == SKINCOLOR_RED
					metalimage.color = SKINCOLOR_METALIMAGE_GREEN
				else
					metalimage.color = SKINCOLOR_METALIMAGE_ORANGE
				end
			end
		end
		if (((leveltime-3)/2) & 1)
			if not player.charging
				if not player.powers[pw_super]
					if flashcolor
						player.mo.colorized = true
						player.mo.color = flashcolor
					end
				else
					player.mo.colorized = true
				end
			end
		else
			if not player.powers[pw_super]
				player.mo.color = player.skincolor
			end
			player.mo.colorized = false
		end
	else
		if not player.powers[pw_super]
			player.mo.color = player.skincolor
		end
		player.normalspeed = skins[player.mo.skin].normalspeed
		player.mo.colorized = false
	end
	
	--Big Jump
	if player.vboost_cooldown == nil or P_IsObjectOnGround(player.mo)
		player.vboost_cooldown = 0
	end
	if player.vboost_cooldown > 0
		player.vboost_cooldown = $-1
	end
	if player.vboost_timer
		player.vboost_timer = max($-1, 0)
	end
	if player.vboosting
		--P_InstaThrust(player.mo, player.mo.angle, 0)
		if player.powers[pw_shield] == SH_THUNDERCOIN
			A_BossScream(player.mo, 0, MT_WATERZAP)
		end
	end
	if player.vboost_timer == TICRATE/4 and player.vboosting
		local visualcue = P_SpawnGhostMobj(player.mo)
		visualcue.scale = player.mo.scale*3/2
	end
	if player.vboost_timer == 0 and player.vboosting
		if player.cmd.buttons&BT_SPIN
			if player.powers[pw_shield] != SH_ARMAGEDDON
				CMS.StartCharge(player, "boost")
			else
				CMS.StartCharge(player, "armageddon")
			end
		elseif player.cmd.buttons&BT_JUMP
			CMS.StartCharge(player, "blast")
		end
		player.vboosting = false
	end
	
	--Charge Code
	if player.charging and not P_IsObjectOnGround(player.mo)
		P_InstaThrust(player.mo, player.mo.angle, 0)
		player.secondjump = 0
		if(player.cmd.buttons&BT_SPIN or player.cmd.buttons&BT_JUMP)
		and player.charge_timer < TICRATE*3
			if player.cmd.buttons&BT_JUMP and not(player.cmd.buttons&BT_SPIN)
				player.charge_type = "blast"
			elseif player.cmd.buttons&BT_SPIN and not(player.cmd.buttons&BT_JUMP)
				player.charge_type = "boost"
			end
			if player.charge_type == "blast"
				if not player.a
					player.a = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_ENERGYAURA)
					if player.a and player.a.valid then 
						player.a.target = player.mo
						player.a.scale = player.mo.scale
						player.a.spriteyoffset = -16*FRACUNIT
					end
				end
				if player.charge_timer == TICRATE*2
					if not player.sound_done
						local visualcue = P_SpawnGhostMobj(player.mo)
						visualcue.scale = player.mo.scale*3/2
						player.sound_done = true
					end
					S_StartSound(player.mo, sfx_s3kb3)
				end
				player.t = P_LookForEnemies(player)
				if player.t
					P_SpawnLockOn(player, player.t, mobjinfo[MT_LOCKON].spawnstate)
				end
			end
			player.mo.state = S_PLAY_METALAIM
			player.charge_timer = $+1
			if not player.powers[pw_super]
				player.charge_speed = min($+FRACUNIT, FRACUNIT*170)
			else
				player.charge_speed = min($+FRACUNIT*3, FRACUNIT*170)
			end
			local gather = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z+player.mo.height/2,MT_ENERGYGATHER)
			if gather and gather.valid then
				gather.target = player.mo
				gather.fuse = 35
				gather.extravalue1 = P_RandomRange(0,359)*ANG1
				gather.extravalue2 = P_RandomRange(0,359)*ANG1
				gather.scale = player.mo.scale/4
			end
			if player.charge_speed >= skins[player.mo.skin].maxdash
			and player.charge_type == "boost"
			and not player.sound_done
				local visualcue = P_SpawnGhostMobj(player.mo)
				visualcue.scale = player.mo.scale*3/2
				player.sound_done = true
			end
		else
			if player.charge_type == "boost"
				S_StopSoundByID(player.mo, sfx_bechrg)
				CMS.StartRocketBoost(player, player.charge_speed, false, sfx_s3k54, false)
				player.charging = false
			elseif player.charge_type == "armageddon"
				S_StopSoundByID(player.mo, sfx_s3k53)
				CMS.StartRocketBoost(player, player.charge_speed, false, sfx_s3k54, false)
			elseif player.charge_type == "blast"
				S_StopSoundByID(player.mo, sfx_bechrg)
				S_StartSound(player.mo, sfx_s3k54)
				player.mo.state = S_PLAY_SPRING
				P_InstaThrust(player.mo, player.drawangle+ANGLE_180, 8*FRACUNIT)
				local blast
				if player.t
					blast = P_SpawnPointMissile(player.mo, player.t.x, player.t.y, player.t.z, MT_ENERGYBLAST, player.mo.x, player.mo.y, player.mo.z)
				else
					blast = CMS.SpawnMissile(player.mo, MT_ENERGYBLAST)
				end
				if blast and blast.valid then
					blast.scale = max(min((player.charge_timer/TICRATE)*FRACUNIT, FRACUNIT*3/2), FRACUNIT/2)
					if not player.t
						P_InstaThrust(blast, blast.angle, 28*blast.scale)
					end
					if G_GametypeHasTeams() then
						blast.colorized = true
						blast.color = player.mo.color
					end
				end
				player.charging = false
			end
		end
		if player.charge_timer == 3*TICRATE
			if player.charge_type == "boost"
				S_StopSoundByID(player.mo, sfx_bechrg)
				CMS.StartRocketBoost(player, player.charge_speed, false, sfx_s3k54, false)
				player.charging = false
			elseif player.charge_type == "blast"
				S_StopSoundByID(player.mo, sfx_bechrg)
				S_StartSound(player.mo, sfx_s3k54)
				player.mo.state = S_PLAY_SPRING
				P_InstaThrust(player.mo, player.drawangle+ANGLE_180, 8*FRACUNIT)
				local blast 
				if player.t
					blast = P_SpawnPointMissile(player.mo, player.t.x, player.t.y, player.t.z, MT_ENERGYBLAST, player.mo.x, player.mo.y, player.mo.z)
				else
					blast = CMS.SpawnMissile(player.mo, MT_ENERGYBLAST)
				end
				if blast and blast.valid then
					blast.scale = max(min((player.charge_timer/TICRATE)*FRACUNIT, FRACUNIT*3/2), FRACUNIT/2)
					P_InstaThrust(blast, player.drawangle, 28*blast.scale)
					if G_GametypeHasTeams() then
						blast.colorized = true
						blast.color = player.mo.color
					end
				end
				player.charging = false
			end
		end
		if not S_SoundPlaying(player.mo, sfx_s3k54) and player.charge_type == "armageddon"
			P_BlackOw(player)
			P_RemoveShield(player)
			CMS.StartRocketBoost(player, 120*FRACUNIT, false, sfx_s3k54, false)
		end
		CMS.SetMomZ(player.mo, -FRACUNIT/2)
		SpriteLib.VWave(player.mo, 4)
	elseif player.charging
		player.charging = false
		S_StopSoundByID(player.mo, sfx_bechrg)
		S_StopSoundByID(player.mo, sfx_s3k53)
	end
	if player.charge_timer == nil or P_IsObjectOnGround(player.mo)
		player.charge_timer = 0
	end
	if player.sound_done == nil or P_IsObjectOnGround(player.mo)
		player.sound_done = false
	end
	if player.store_speed == nil or P_IsObjectOnGround(player.mo)
		player.store_speed = 0
	end
	if player.charge_type == nil or P_IsObjectOnGround(player.mo)
		player.charge_type = "none"
	end
	
--	 Rocket Boost Stuff
	if player.boost_cooldown == nil or P_IsObjectOnGround(player.mo)
		player.boost_cooldown = 0
	end
	if player.boost_cooldown > 0
		player.boost_cooldown = $-1
	end
	if player.boost_canceled == nil
		player.boost_canceled = false
	end
	if player.boost_canceled 
	and (P_IsObjectOnGround(player.mo) or player.mo.eflags&MFE_SPRUNG)
		player.boost_canceled = false
		player.mo.rollangle = 0
		player.drawangle = player.startangle
	end
	if player.boost_canceled
		player.mo.rollangle = $+ANGLE_22h
		player.drawangle = $+ANGLE_45
		if player.boost_canceled
			player.powers[pw_nocontrol] = 1
		end
	end
	if player.boost_timer
		player.boost_timer = max($-1,0)
	end
	if player.rboosting
		if player.rboost_setmomz
			if player.powers[pw_shield] == SH_WHIRLWIND
			or (player.powers[pw_shield] == SH_THUNDERCOIN)
				if (player.powers[pw_shield] == SH_THUNDERCOIN)
					A_BossScream(player.mo, 0, MT_WATERZAP)
				end
				P_SetObjectMomZ(player.mo, FRACUNIT*24)
			elseif (player.powers[pw_shield] == SH_ELEMENTAL)
			or (player.powers[pw_shield] == SH_BUBBLEWRAP)
				P_SetObjectMomZ(player.mo, -FRACUNIT*32)
			else
				P_SetObjectMomZ(player.mo, 0)
			end
		end
		if (player.powers[pw_shield] == SH_FLAMEAURA)
		or player.powers[pw_shield] == SH_ELEMENTAL
			P_InstaThrust(player.mo, player.startangle, player.start_speed+40*FRACUNIT)
		else
			P_InstaThrust(player.mo, player.startangle, player.start_speed)
		end
		player.drawangle = player.startangle
		player.mo.state = S_PLAY_DASH
		if player.followmobj
			local jetghost = P_SpawnGhostMobj(player.followmobj)
			jetghost.fuse = 3
			jetghost.color = jetcolor or SKINCOLOR_YELLOW
			jetghost.scalespeed = FRACUNIT/4
			jetghost.destscale = 0
		end
	end
	if player.boost_timer == 0 and player.rboosting
	or (P_IsObjectOnGround(player.mo) or player.mo.eflags&MFE_SPRUNG) and player.rboosting
		if not P_IsObjectOnGround(player.mo) and not player.secondjump
		and not player.boost_canceled
		and player.rboost_setmomz
			player.mo.state = S_PLAY_FALL
		end
		if player.powers[pw_shield]&SH_FORCE and player.powers[pw_shield]&SH_FORCEHP
		and not P_IsObjectOnGround(player.mo)
			P_InstaThrust(player.mo, player.drawangle, player.speed/2)
			S_StartSound(player.mo, sfx_ngskid)
			player.pflags = $|PF_SHIELDABILITY
		elseif player.powers[pw_shield] == SH_ARMAGEDDON
		and not P_IsObjectOnGround(player.mo)
			P_BlackOw(player)
			P_RemoveShield(player)
		end
		player.rboosting = false
	end
	if player.rboost_setmomz == nil or P_IsObjectOnGround(player.mo)
		player.rboost_setmomz = false
	end
	if player.followmobj and jetcolor
		player.followmobj.color = jetcolor
	end
end)

addHook("PlayerSpawn", function(player)
	if player.mo and player.mo.valid and P_IsObjectOnGround(player.mo)
		player.mo.state = S_PLAY_STND
	end
	player.mo.rollangle = 0
	player.metaldj = false
	if player.metalshield != nil
		P_SwitchShield(player, player.metalshield)
	end
end)

addHook("JumpSpinSpecial",function(player)
	for player in players.iterate do
	
		--Rocket Boost
		if player.mo.skin == "cosmicmetal"
			if not(player.pflags&PF_USEDOWN)
			and player.boost_cooldown == 0
			and not player.vboosting
			and not player.charging
--			and player.energy >= 5
				if player.powers[pw_shield] == SH_PITY then S_StartSound(player.mo, sfx_pity) end

				if not player.powers[pw_super]
					CMS.StartRocketBoost(player, player.speed+50*FRACUNIT, true, sfx_kc40, true)
				else
					CMS.StartRocketBoost(player, player.speed+85*FRACUNIT, true, sfx_kc40, true)
				end
				return true
			end
		end
	end
end)

addHook("AbilitySpecial", function(player)
	if player.mo.skin == "cosmicmetal"
	and player.vboost_cooldown == 0
	and not player.rboosting
		player.store_speed = max(player.speed, 20*FRACUNIT)
		if not(player.mo.eflags&MFE_UNDERWATER)
			player.start_momz = 16*FRACUNIT
		else
			player.start_momz = 8*FRACUNIT
		end
		P_InstaThrust(player.mo, player.mo.angle, FixedDiv(FixedHypot(player.rmomx, player.rmomy),player.mo.scale)/2)
		P_SetObjectMomZ(player.mo, player.start_momz)
		S_StartSound(player.mo, sfx_beflap)
		player.vboost_timer = TICRATE*3/4
		player.vboosting = true
		player.vboost_cooldown = TICRATE*8
		player.mo.state = S_PLAY_SPRING
		return true
	end
end)

addHook("ShieldSpecial", function(player)
	if player.mo.skin == "cosmicmetal"
		return true
	end
end)

addHook("MobjDamage", function(pmo, enemy, source)
	if pmo.skin == "cosmicmetal"
		if P_RandomRange(0, 3) == 1
			P_DoPlayerPain(pmo.player, source, enemy)
			P_PlayDeathSound(pmo)
		else
			return false
		end
	end
end, MT_PLAYER)